### Copyright (C) 1997 Robert E. Blue (reblue@emry.net)
### This program is free software; you can redistribute it and/or modify
### it under the terms of the GNU General Public License as published by
### the Free Software Foundation; either version 2 of the License, or
### (at your option) any later version.
###
### This program is distributed in the hope that it will be useful,
### but WITHOUT ANY WARRANTY; without even the implied warranty of
### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
### GNU General Public License for more details.
###
### You should have received a copy of the GNU General Public License
### along with this program; if not, write to the Free Software
### Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


proc getfile_window {args} {
    global argv
    set w [toplevel .topGetFile]

    wm title $w "httpd.conf location"

    label $w.label\
	-text "Please enter the full path including filename of your"\
	      "httpd.conf"

    frame $w.frame
    entry $w.entry -width 30 -textvariable fileEntry
    button $w.browser \
	-command {
	    set fileEntry [join [lrange [FileDirBrowser -dir [file dirname $fileEntry] -file [file tail $fileEntry]] 0 1] ""]
	}\
	-bitmap @[lindex $argv 0]/bitmaps/folder_center.xbm

    pack $w.entry $w.browser -side left -in $w.frame

    button $w.okbutton -text "Ok"\
	-command {
	    destroy .topGetFile
	    set fileEntryA $fileEntry
	}
    
    pack $w.label $w.frame $w.okbutton\
	-padx 5 -pady 5

    $w.entry insert 0 "~/httpd.conf"
			
    tkwait window $w
}

proc apache1.2-parser {fileName list} {

    global fileEntryA
    set vnum 0

    getfile_window

    set httpdconf [open $fileEntryA]

    while {![eof $httpdconf]} {
	
	gets $httpdconf line
	
	if [regexp {^\#} $line || regexp {^\n} $line] {
	    gets $httpdconf line
	}

###########################################################################
### Parse everything between <VirtualHost xxx.xxx.xxx> and </VirtualHost>
###  and put everything into special arrays.

    if [regexp {^\<VirtualHost} $line] {
	incr vnum
	while {![regexp {^</VirtualHost>} $line]} {
	    gets $httpdconf line
	    
	    if [regexp {^ServerName (.*)$} $line all vservername($vnum)] {
		continue
	    }
	    if [regexp {^ServerAdmin (.*)$} $line all vserveradmin($vnum)] {
		continue
	    }
	    if [regexp {^DocumentRoot (.*)$} $line all vdocumentroot($vnum)] {
		continue
	    }
	    if [regexp {^ErrorLog (.*)$} $line all verrorlog($vnum)] {
		continue
	    }
	    if [regexp {^TransferLog (.*)$} $line all vtransferlog($vnum)] {
		continue
	    }
	    if [regexp {^RefererLog (.*)$} $line all vrefererlog($vnum)] {
		continue
	    }
	}
    }
    
    if [regexp {^ServerName (.*)$} $line all file(servername)] {
	continue
    }
    if [regexp {^ServerAdmin (.*)$} $line all file(serveradmin)] {
	continue
    }
    if [regexp {^ServerType (.*)$} $line all file(servertype)] {
	continue
    }	
    if [regexp {^Port (.*)$} $line all file(port)] {
	continue
    }	
    if [regexp {^ServerRoot (.*)$} $line all file(serverroot)] {
	continue
    }
    if [regexp {^User (.*)$} $line all file(user)] {
	continue
    }
    if [regexp {^Group (.*)$} $line all file(group)] {
	continue
    }
    if [regexp {^ErrorLog (.*)$} $line all file(errorlog)] {
	continue
    }
    if [regexp {^TransferLog (.*)$} $line all file(transferlog)] {
	continue
    }
    if [regexp {^RefererLog (.*)$} $line all file(refererlog)] {
	continue
    }
    if [regexp {^ScoreBoardFile (.*)$} $line all file(scoreboardfile)] {
	continue
    }
    if [regexp {^PidFile (.*)$} $line all file(pidfile)] {
	continue
    }
    if [regexp {^HostnameLookups (.*)$} $line all file(hostnamelookups)] {
	continue
    }
    if [regexp {^StartServers (.*)$} $line all file(startservers)] {
	continue
    }
    if [regexp {^MinSpareServers (.*)$} $line all file(minspareservers)] {
	continue
    }
    if [regexp {^MaxSpareServers (.*)$} $line all file(maxspareservers)] {
	continue
    }
    if [regexp {^MaxClients (.*)$} $line all file(maxclients)] {
	continue
    }
    if [regexp {^MaxRequestsPerChild (.*)$} $line all file(maxrequestsperchild)] {
	continue
    }
    if [regexp {^KeepAlive (.*)$} $line all file(keepalive)] {
	continue
    }
    if [regexp {^KeepAliveTimeout (.*)$} $line all file(keepalivetimeout)] {
	continue
    }
    if [regexp {^Timeout (.*)$} $line all file(timeout)] {
	continue
    }
    
}
	
    close $httpdconf
    set File [open $fileName w]


##########################################
 ### Export the main server information ###
  ##########################################
  
puts $File "page httpd-conf-main"
	
    if {[info exist file(servername)]} {
	puts $File "ENTRY servernameEntry \"$file(servername)\""
    }
    if {[info exist file(serveradmin)]} {
	puts $File "ENTRY adminEntry \"$file(serveradmin)\""
    }
    if {[info exist file(serverroot)]} {
	puts $File "ENTRY serverrootEntry \"$file(serverroot)\""
    }
    if {[info exist file(port)]} {
	puts $File "INT portInt \"$file(port)\""
    }
    if {[info exist file(user)]} {
	puts $File "ENTRY userEntry \"$file(user)\""
    }
    if {[info exist file(group)]} {
	puts $File "ENTRY groupEntry \"$file(group)\""
    }

########################################
 ### Export main log file information ###
  ########################################
  
    puts $File "PAGE httpd-conf-logs"

    if {[info exist file(errorlog)]} {
	puts $File "CHECKBOX errorlogCB \"1\""
	puts $File "ENTRY errorlogFDB \"$file(errorlog)\""
	puts $File "COMMAND com_errorlogFDB \"$file(errorlog)\""
    }
    if {[info exist file(transferlog)]} {
	puts $File "CHECKBOX transferlogCB \"1\""
	puts $File "ENTRY transferlogFDB \"$file(transferlog)\""
	puts $File "COMMAND com_transferlogFDB \"$file(transferlog)\""
    }
    if {[info exist file(refererlog)]} {
	puts $File "CHECKBOX refererlogCB \"1\""
	puts $File "ENTRY refererlogFDB \"$file(refererlog)\""
	puts $File "COMMAND com_refererlogFDB \"$file(refererlog)\""
    }
    if {[info exist file(scoreboardfile)]} {
	puts $File "CHECKBOX scoreboardfileCB \"1\""
	puts $File "ENTRY scoreboardfileFDB \"$file(scoreboardfile)\""
	puts $File "COMMAND com_scoreboardfileFDB \"$file(scoreboardfile)\""
    }
    if {[info exist file(pidfile)]} {
	puts $File "CHECKBOX pidfileCB \"1\""
	puts $File "ENTRY pidfileFDB \"$file(pidfile)\""
	puts $File "COMMAND com_pidfileFDB \"$file(pidfile)\""
    }
    if {[info exist file(hostnamelookups)]} {
	if {[string tolower $file(hostnamelookups)] == "on"} {
	    puts $File "CHECKBOX hostnamelookupsCB \"1\""
	} else {
	    puts $File "CHECKBOX hostnamelookupsCB \"0\""
	}
    }


###########################################
 ### Export the optimization information ###
  ###########################################

    puts $File "PAGE httpd-conf-optimize"

    if {[info exist file(startservers)]} {
	puts $File "INT startInt \"$file(startservers)\""
    }
    if {[info exist file(minspareservers)]} {
	puts $File "INT minspareInt \"$file(minspareservers)\""
    }
    if {[info exist file(maxspareservers)]} {
	puts $File "INT maxspareInt \"$file(maxspareservers)\""
    }
    if {[info exist file(maxrequestsperchild)]} {
	puts $File "INT maxreqInt \"$file(maxrequestsperchild)\""
    }
    if {[info exist file(maxclients)]} {
	puts $File "INT maxclientsInt \"$file(maxclients)\""
    }
    if {[info exist file(keepalive)]} {
	puts $File "CHECKBOX keepaliveCB \"1\""
	puts $File "INT keepaliveInt \"$file(keepalive)\""
    }
    if {[info exist file(keepalivetimeout)]} {
	puts $File "INT keepalivetimeoutInt \"$file(keepalivetimeout)\""
    }
    if {[info exist file(timeout)]} {
	puts $File "INT timeoutInt \"$file(timeout)\""
    }


#########################################
 ### Export the virtual hosts ExtEntry ###
  #########################################
  
    if {$vnum} {
	puts $File "page httpd-conf-virtual"
	puts $File "EXTENTRY virtualExt"

	while {$vnum} {
	    puts $File "\{"
	    if {[info exist vservername($vnum)]} {
		puts $File "ENTRY vhostEntry \"$vservername($vnum)\""
	    }
	    if {[info exist vserveradmin($vnum)]} {
		puts $File "ENTRY vadminEntry \"$vserveradmin($vnum)\""
	    }
	    if {[info exist vdocumentroot($vnum)]} {
		puts $File "ENTRY vdocrootEntry \"$vdocumentroot($vnum)\""
	    }
	    if {[info exist verrorlog($vnum)]} {
		puts $File "CHECKBOX verrorCB \"1\""
		puts $File "ENTRY verrorFDB \"$verrorlog($vnum)\""
		puts $File "COMMAND com_verrorFDB \"$verrorlog($vnum)\""
	    }
	    if {[info exist vtransferlog($vnum)]} {
		puts $File "CHECKBOX vtransferCB \"1\""
		puts $File "ENTRY vtransferFDB \"$vtransferlog($vnum)\""
	    }
	    if {[info exist vrefererlog($vnum)]} {
		puts $File "CHECKBOX vrefererCB \"1\""
		puts $File "ENTRY vrefererFDB \"$vrefererlog($vnum)\""
	    }
	    if {[info exist vdocumentroot($vnum)]} {
		puts $File "ENTRY vdocrootEntry \"$vdocumentroot($vnum)\""
	    }
	    if {[info exist vhostnamelookups($vnum)]} {
		if {[string tolower vhostnamelookups($vnum)] == "on"} {
		    puts $File "CHECKBOX vhostnamelookupsCB \"1\""
		} else {
		    puts $File "CHECKBOX vhostnamelookupsCB \"0\""
		}
	    }
	    
	    puts $File "\}"
	    set vnum [expr $vnum-1]
	}
    }
    
    close $File
}
